# -*- coding=utf8 -*-
#******************************************************************************
# ConvertPlaylist.py
#------------------------------------------------------------------------------
#
# Copyright (c) 2015 LivingOn <LivingOn@xmail.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#******************************************************************************
from resources.lib.MediaTypes import SingleMediaFile, PlaylistFile, NoMediaFile

def convert(movie_library, serie_library, playlist_file):
    for line in _read_content(playlist_file):
        mediatype = _create_mediatypes(line, movie_library, serie_library)
        mediatype.create_strm_files()
            
def _create_mediatypes(line, movie_library, serie_library):
    strip = lambda x: x.strip()
    line = strip(line)
    if line and not line.startswith("#"):
        p = line.split("|")
        title = strip(p[0])
        if len(p) == 2:
            vid = strip(p[1])
            if vid.startswith("PL") and len(vid) > 11:
                return PlaylistFile(serie_library, title, vid)
            else:
                return SingleMediaFile(movie_library, title, vid)
        elif len(p) == 3:
            season = strip(p[1])
            vid = strip(p[2])
            return SingleMediaFile(serie_library, title, vid, season)
    return NoMediaFile()

def _read_content(playlistfile):
    try:
        content = open(playlistfile, "rU").readlines()
    except IOError:
        content = []
    return content
