# -*- coding=utf8 -*-
#******************************************************************************
# SxxExxKennung.py
#------------------------------------------------------------------------------
#
# Copyright (c) 2015 LivingOn <LivingOn@xmail.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#******************************************************************************
import re

class SxxExxKennung(object):
    
    PATTERN = re.compile(r'S(\d{1,2})E(\d{1,2})')       

    @classmethod
    def parse(cls, title):
        target = cls.PATTERN.findall(_normalize(title))
        if target:
            return "S%02dE%02d" % (int(target[0][0]), int(target[0][1]))
        return None
        
def _normalize(title):
    return title.upper().replace("_", " ").replace(".", " ")
