# -*- coding=utf8 -*-
#******************************************************************************
# YoutubePlaylist.py
#------------------------------------------------------------------------------
#
# Copyright (c) 2015 LivingOn <LivingOn@xmail.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#******************************************************************************
import re
import urllib2
 
class YoutubePlaylist(object):
    PLAYLIST_URL  = "https://www.youtube.com/playlist?list=%s"
    TITLE_PATTERN = re.compile(r'.*data-title=\"(.*?)\"')
    VIDEO_PATTERN = re.compile(r'.*data-video-id=\"(.*?)\"')
 
    @classmethod
    def parse(cls, playlist_id):
        content = []
        for line in urllib2.urlopen(cls.PLAYLIST_URL % playlist_id):
            video_id = _get_match_from(cls.VIDEO_PATTERN, line)
            title    = _get_match_from(cls.TITLE_PATTERN, line)
            if video_id and title:
                content.append((title, video_id))
        return content


def _get_match_from(pattern, line):
    matchobj = pattern.match(line)
    if matchobj:
        return matchobj.group(1)
    return None
